Name: z505
Version: 1.2
%define phdver 1.1
Release: 2
Summary: Configuration files and general fixups needed for running Red Hat Linux on a Sony Z505-series laptop with a 2.4 kernel.
Copyright: GPL
Group: System Environment/Base
Packager: Alex Stewart <alex@foogod.com>
ExclusiveArch: noarch
ExclusiveOS: Linux
Obsoletes: z505h
Requires: pciutils, patch, kernel >= 2.4.0
Source0: z505-phdinst-%{phdver}.tar.gz
Source1: apmcontinue.script
Source2: usb.init
Source3: nfslock-2.4.patch
Source4: z505-system-config.patch
Source5: z505h-system-config.patch
Source6: z505js-kudzu.patch
Source7: XF86Config-usbmouse.patch

BuildRoot: /var/tmp/z505-buildroot

%description
This package serves two functions:
1) It provides all fixups and configuration changes required for clean
   operation of Red Hat Linux 6.2 on the Sony Vaio Z505 hardware.
2) It also provides miscellaneous fixups and changes needed for running a
   2.4-series kernel with a RHL 6.2 system (on any hardware), which do not fit
   anywhere else.
This package is intended to be part of the Z505 linux fixup kit, available at
http://www.foogod.com/z505-linux

%prep
%setup -n z505-phdinst-%{phdver}

%build

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig/apm-scripts
mkdir -p $RPM_BUILD_ROOT/usr/share/z505_update
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/dev/shm

install -m 755 $RPM_SOURCE_DIR/usb.init $RPM_BUILD_ROOT/etc/rc.d/init.d/usb
install -m 755 $RPM_SOURCE_DIR/apmcontinue.script $RPM_BUILD_ROOT/etc/sysconfig/apm-scripts/apmcontinue
install -m 644 $RPM_SOURCE_DIR/nfslock-2.4.patch $RPM_BUILD_ROOT/usr/share/z505_update
install -m 644 $RPM_SOURCE_DIR/z505-system-config.patch $RPM_BUILD_ROOT/usr/share/z505_update
install -m 644 $RPM_SOURCE_DIR/z505h-system-config.patch $RPM_BUILD_ROOT/usr/share/z505_update
install -m 644 $RPM_SOURCE_DIR/z505js-kudzu.patch $RPM_BUILD_ROOT/usr/share/z505_update
install -m 644 $RPM_SOURCE_DIR/XF86Config-usbmouse.patch $RPM_BUILD_ROOT/usr/share/z505_update
install -m 644 $RPM_BUILD_DIR/z505-phdinst-%{phdver}/phdinst_files.tar $RPM_BUILD_ROOT/usr/share/z505_update
install -m 755 $RPM_BUILD_DIR/z505-phdinst-%{phdver}/z505-phdinst $RPM_BUILD_ROOT/usr/sbin

mknod -m 660 $RPM_BUILD_ROOT/dev/usbmouse c 13 63
mknod -m 660 $RPM_BUILD_ROOT/dev/ppp c 108 0

%clean

rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add usb

cd /
/usr/bin/patch -p0 < /usr/share/z505_update/nfslock-2.4.patch > /dev/null
/usr/bin/patch -p0 < /usr/share/z505_update/z505-system-config.patch > /dev/null
/usr/bin/patch -p0 < /usr/share/z505_update/z505js-kudzu.patch > /dev/null

if [ -e /etc/X11/XF86Config ]; then
  /usr/bin/patch -p0 < /usr/share/z505_update/XF86Config-usbmouse.patch > /dev/null
fi

if [ -e /etc/conf.modules -a ! -e /etc/modules.conf ]; then
  mv /etc/conf.modules /etc/modules.conf
  ln -s /etc/modules.conf /etc/conf.modules
fi

# Update /etc/modules.conf

( cat << EOF
  # PPP stuff required for 2.4 kernels
  alias char-major-108    ppp_generic
  alias tty-ldisc-14      ppp_synctty
  # IRDA drivers
  alias tty-ldisc-11 irtty
  alias char-major-161 ircomm_tty
  alias irda0 nsc-ircc
  options nsc-ircc dongle_id=0x09
  pre-install nsc-ircc setserial /dev/ttyS2 port 0 irq 0
EOF
  if lspci -n | grep -q 'Class 0401: 1073'; then
    # Found a Yamaha audio controller.  Install the ymfpci drivers and config
    # patches.
    /usr/bin/patch -p0 < /usr/share/z505_update/z505h-system-config.patch > /dev/null
    echo "# Sound drivers for Yamaha YMF chipset"
    echo "alias sound snd-pcm-oss"
    echo "alias midi snd-seq-oss"
    echo "alias sound-slot-0 snd-card-ymfpci"
  else
    # This must be an older model with the Neomagic sound.  Add the nm256_audio
    # module to modules.conf
    echo "# Sound drivers for Neomagic NM256 chipset"
    echo "alias sound nm256_sound"
  fi
) | while read line; do
  re=`echo $line | sed -e 's/\([][\\.*^$]\)/\\\\\1/g' -e 's/ /[[:space:]]*/g'`
  if ! grep -q "^[[:space:]]*$re" /etc/modules.conf; then
    echo "$line" >> /etc/modules.conf
    echo "$line" >> /usr/share/z505_update/added_modules
  fi
done

cd /dev
[ ! -e /dev/cdrom ] && ln -s hde cdrom

cdrom=`grep '/mnt/cdrom' /etc/fstab`
shm=`grep '/dev/shm' /etc/fstab`
(
  sed -e 's/\/dev\/fd0/\/dev\/sda/'
  if [ -z "$cdrom" ]; then
    echo "/dev/cdrom              /mnt/cdrom              iso9660 noauto,ro,owner 0 0"
  fi
  if [ -z "$shm" ]; then
    echo "none                    /dev/shm                shm     defaults        0 0"
  fi
) < /etc/fstab > /etc/fstab.new
[ -s /etc/fstab.new ] && mv /etc/fstab /etc/fstab.orig && mv /etc/fstab.new /etc/fstab

case `uname -r` in
  2.4.*) [ -z "$shm" ] && mount /dev/shm
         /etc/rc.d/init.d/usb start >/dev/null
         ;;
esac

%preun

/sbin/chkconfig --del usb

cd /
/usr/bin/patch -p0 -R < /usr/share/z505_update/nfslock-2.4.patch > /dev/null
/usr/bin/patch -p0 -R < /usr/share/z505_update/z505-system-config.patch > /dev/null
/usr/bin/patch -p0 -R < /usr/share/z505_update/z505h-system-config.patch > /dev/null
/usr/bin/patch -p0 -R < /usr/share/z505_update/z505js-kudzu.patch > /dev/null
/usr/bin/patch -p0 -R < /usr/share/z505_update/XF86Config-usbmouse.patch > /dev/null

cd /usr/share/z505_update
cp /etc/modules.conf /tmp/modules.conf.old && \
fgrep -vxf added_modules /tmp/modules.conf.old > /etc/modules.conf
rm -f added_modules

echo -e '/^none[ \t]*[/]dev[/]shm[ \t]*shm[ \t]*defaults[ \t]*0 0$/d\nwq' | ed -s /etc/fstab
umount /dev/shm 2>/dev/null

%files
%defattr(-,root,root)
%config /etc/rc.d/init.d/usb
%config /etc/sysconfig/apm-scripts/apmcontinue
/usr/share/z505_update
/usr/sbin/z505-phdinst
%dir /dev/shm
/dev/usbmouse
/dev/ppp

%changelog
* Thu Oct 19 2000 Alex Stewart <alex@foogod.com>
- Fixed filename in XF86Config-usbmouse.patch script so it will actually apply
  correctly now.

* Mon Oct 2 2000 Alex Stewart <alex@foogod.com>
- Added support for USB mouse/keyboard
- Cleaned up aesthetics of usb initscript
- Changed install script to configure for Neomagic driver if no Yamaha sound
  chip was found.
- Improved code for adding/removing lines to modules.conf
- Added modules.conf entries for IRDA support
- Added modules.conf entries and /dev entry for PPP under 2.4
- Added a fix for sound or ethernet locking up the system if USB floppy is
  connected during boot.

* Sun Aug 27 2000 Alex Stewart <alex@foogod.com>
- Renamed package to "z505" instead of "z505h", as it now applies to other
  models as well.
- Updated to version 1.1 of the phdinst package (fixes problems when FAT
  partition is not hda1)
- Added kudzu patches for Z505JS video chipset
- Added check for presence of YMF chipset before configuring for it, so this
  RPM should work ok on older (non-YMF) models too.
- Added fix for nfslock init script for use with 2.4 kernels.

* Sat Aug 12 2000 Alex Stewart <alex@foogod.com>
- Initial release.
